/* AP 05-04-00 frontend to COM calculator		*/
/*    18-01-01 create 2 COM objects	with state	*/

# include <stdio.h>
# include <stdlib.h>
# include "Calculator.h"


/* include type and constant definitions */
# include "Calculator_i.c"




# define QUIT -1
# define SUM 0
# define MUL 1
# define SUB 2
# define DIV 3

int compute (ICalc *pCalc ) {
	int x = 0, y = 0, z = 0, i = 0;
	int l;
	int op, exit_flag = 0;
	char buf[255];
	
	while (!exit_flag) {
		printf("enter values...\n");
		gets( buf );
		if (buf[0] == 'm' ) pCalc->getMem( &l ), x = l;
		else x = atoi( buf );
		gets( buf );
		switch ( buf[0] ) {
			case '+': op = SUM; break;
			case '-': op = SUB; break;
			case 'q': op = QUIT; exit_flag = 1; continue;
			case 'm': pCalc->putMem( x ); continue;
			default: op = SUM;
		}
		gets( buf );
		if (buf[0] == 'm' ) pCalc->getMem( &l ), y = l;
		else y = atoi( buf );

		switch (op) {
			case SUM:
				pCalc->Add( x, y, &z );
				printf("pCalc->Sum( %d, %d ) returns: %d \n", x, y, z );
				break;
			case SUB:
				pCalc->Sub( x, y, &z );
				printf("pCalc->Sub( %d, %d ) returns: %d \n", x, y, z );
				break;
			case QUIT: exit_flag = 1; break;
			default: break;
		}
	}
	return 0;
}


main (int argc, char ** argv ) {
	int x = 0, y = 0, z = 0;
	int i = 0;
	
	if (argc-- > 1) x = atoi(argv[++i]);
	if (argc-- > 1) y = atoi(argv[++i]);
	
	IUnknown	*pUnknown;
	ICalc		*pCalc, *pCalc2;
	HRESULT		hr;
	
	CoInitialize( NULL );
	hr = CoCreateInstance( CLSID_Calc, NULL, CLSCTX_SERVER, IID_IUnknown, (void **) &pUnknown );
	if (FAILED(hr)) {
		printf("Could not create Calculator Component, exiting...\n");
		exit(1);
	}
	pUnknown->QueryInterface( IID_ICalc, (void **) &pCalc );
	pUnknown->Release();

	CoCreateInstance( CLSID_Calc, NULL, CLSCTX_SERVER, IID_IUnknown, (void **) &pUnknown );
	pUnknown->QueryInterface( IID_ICalc, (void **) &pCalc2 );
	pUnknown->Release();


	compute( pCalc );
	
	
	/*pCalc->Add( x, y, &z );
	printf("pCalc->Add( %d, %d ) returns: %d \n", x, y, z );
	pCalc->getMem( &z );
	printf("pCalc->getMem() returns: %d \n", z );

	pCalc2->Mult( x, y, &z );
	printf("pCalc2->Mult( %d, %d ) returns: %d \n", x, y, z );
	pCalc2->getMem( &z );
	printf("pCalc2->getMem() returns: %d \n", z );
*/
	pCalc->Release();
	pCalc2->Release();
	CoUninitialize();

	return 0;
}